#ifndef CSR_H
#define CSR_H

/* ZICSR : Control and Status Registers */
#define CSR_COUNT 0x2000

/* Supervisor-level CSR */
/* Supervisor Trap setup CSR */
#define CSR_SSTATUS 0x100
#define CSR_SIE 0x104
#define CSR_STVEC 0x105
#define CSR_SCOUNTEREN 0x106
#define CSR_SENVCFG 0x10A
/* Supervisor Trap handling CSR */
#define CSR_SSCRATCH 0x140
#define CSR_SEPC 0x141
#define CSR_SCAUSE 0x142
#define CSR_STVAL 0x143
#define CSR_SIP 0x144
/* Supervisor Protection/Translation CSR */
#define CSR_SATP 0x180
/* Debug/Trace CSR */
#define CSR_SCONTEXT 0x5A8

/* Machine-level CSR */
#define CSR_MVENDORID 0xF11
#define CSR_MARCHID 0xF12
#define CSR_MIMPID 0xF13
#define CSR_MHARTID 0xF14
#define CSR_MCONFIGPTR 0xF15
/* Machine Trap setup CSR */
#define CSR_MSTATUS 0x300
#define CSR_MISA 0x301
#define CSR_MEDELEG 0x302
#define CSR_MIDELEG 0x303
#define CSR_MIE 0x304
#define CSR_MTVEC 0x305
#define CSR_MCOUNTEREN 0x306
#define CSR_MSTATUSH 0x310
/* Machine Trap handling CSR */
#define CSR_MSCRATCH 0x340
#define CSR_MEPC 0x341
#define CSR_MCAUSE 0x342
#define CSR_MTVAL 0x343
#define CSR_MIP 0x344
#define CSR_MTINST 0x34A
#define CSR_MTVAL2 0x34B
/* Machine Configuration */
#define CSR_MENVCFG 0x30A
#define CSR_MENVCFGH 0x31A
#define CSR_MSECCFG 0x747
#define CSR_MSECCFGH 0x757
/* Machine Memory Protection */
#define CSR_PMPCFG0 0x3A0

#endif
